{-# OPTIONS -fglasgow-exts #-}
module Deus.With (with,LocalSetting(..)) where

import Graphics.Rendering.OpenGL

data LocalSetting =
      forall a g . (HasGetter g,HasSetter g) => g a := a
    | forall a g . (HasGetter g,HasSetter g) => Preserving (g a)

save (a := b)       = (a :=) `fmap` get a
save (Preserving a) = (a :=) `fmap` get a

apply (a := b)       = a $= b
apply (Preserving a) = return ()

-- Goes to some trouble to ensure that even non-independent
-- LocalSettings work OK, by only saving each one immediately
-- before changing it (in case a previous setting change
-- affects this one) and reapplying in reverse order

with :: [LocalSetting] -> IO t -> IO t
with lss act = do olds <- mapM (\ls -> do saved <- save ls
                                          apply ls
                                          return saved) lss
                  ret <- act
                  mapM_ (\ls -> apply ls) (reverse olds)
                  return ret
